/**
 * EIVLTS2.java
 *
 * File generated from the medication2::EIVLTS2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class EIVLTS2.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EIVL_TS", propOrder = {
	"event",
	"offset"
})
@XmlRootElement(name = "EIVL_TS")
public class EIVLTS2 extends net.ihe.gazelle.medication2.SXCMTS2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                      .
	 */
	@XmlElement(name = "event", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.EIVLEvent2 event;
	/**
	 *                          An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                      .
	 */
	@XmlElement(name = "offset", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.IVLPQ2 offset;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return event.
	 * @return event :                          A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                      
	 */
	public net.ihe.gazelle.medication2.EIVLEvent2 getEvent() {
	    return event;
	}
	
	/**
	 * Set a value to attribute event.
	 * @param event :                          A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                      .
	 */
	public void setEvent(net.ihe.gazelle.medication2.EIVLEvent2 event) {
	    this.event = event;
	}
	
	
	
	
	/**
	 * Return offset.
	 * @return offset :                          An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                      
	 */
	public net.ihe.gazelle.medication2.IVLPQ2 getOffset() {
	    return offset;
	}
	
	/**
	 * Set a value to attribute offset.
	 * @param offset :                          An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                      .
	 */
	public void setOffset(net.ihe.gazelle.medication2.IVLPQ2 offset) {
	    this.offset = offset;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "EIVL_TS").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(EIVLTS2 eIVLTS2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eIVLTS2 != null){
   			net.ihe.gazelle.medication2.SXCMTS2.validateByModule(eIVLTS2, _location, cvm, diagnostic);
			net.ihe.gazelle.medication2.EIVLEvent2.validateByModule(eIVLTS2.getEvent(), _location + "/event", cvm, diagnostic);
			net.ihe.gazelle.medication2.IVLPQ2.validateByModule(eIVLTS2.getOffset(), _location + "/offset", cvm, diagnostic);
    	}
    }

}
